#!/bin/sh

pkg=$1
ver=$2
arch=$3
dist=$4

mkdir -p "$dist"
cd "$dist" || exit 1

{{ rebuildd_fetch_code_to_identify_mirror }}

# Drop epoch from version
ver2=$(expr "$ver" : '[0-9]\+:\(.*\)')
if [ -n "$ver2" ]; then
    ver=$ver2
fi

# Job file has the version with the binnmu suffix but no epoch
jobfile=${pkg}_${ver}_${arch}.job

# Drop binnmu suffix (the dsc file has no such suffix)
ver2=$(expr "$ver" : '\(.*\)+b[0-9]\+')
if [ -n "$ver2" ]; then
    ver=$ver2
fi

hash=$(expr "$pkg" : '\(lib.\)')
hash=${hash:-$(expr "$pkg" : '\(.\)')}

for c in main contrib non-free non-free-firmware; do
    dscurl="$mirror/$c/$hash/$pkg/${pkg}_$ver.dsc"
    dsc="$(pwd)/${pkg}_$ver.dsc"
    if HEAD -d "$dscurl" >/dev/null; then
	dget -q -d "$dscurl"
        echo "$dsc" >"$jobfile"
        echo "Recorded job $jobfile building $dsc"
        exit 0
    fi
done

echo "ERROR: Source package ${pkg}_$ver.dsc not found in $mirror" >&2
exit 1
